/*
* mpaf7.c                                                   Version 5.2.0
*
* Default MPA and MPA templates for STM32F7xx processors.
*
* Copyright (c) 2017-2023 Micro Digital Inc.
* All rights reserved. www.smxrtos.com
*
* This software is confidential and proprietary to Micro Digital Inc.
* It has been furnished under a license and may be used, copied, or
* disclosed only in accordance with the terms of that license and with
* the inclusion of this header. No title to nor ownership of this
* software is hereby transferred.
*
* Author: Ralph Moore, David Moore
*
*****************************************************************************/

#include "smx.h"
#include "mpatmplt.h"

#if SMX_CFG_MPU

/* region sizes <1> */
extern u32 ramsz;
extern u32 romsz;
extern u32 sramsz;

/* sections <1> <2> */
#pragma section = "ram_block"
#pragma section = "rom_block"
#pragma section = "sram_block"

/*===========================================================================*
                         PMODE MPA_DFLT AND TEMPLATES
*===========================================================================*/

/* Default MPA */
MPA mpa_dflt = 
{
   RGN(0 | RA("rom_block") | V, PCODE   | SRD("rom_block") | RSI("rom_block") | EN, "rom_block"),
   RGN(1 | RA("sram_block")| V, PDATARW | SRD("sram_block")| RSI("sram_block")| EN, "sram_block"),
   RGN(2 | RA("ram_block") | V, PDATARW | SRD("ram_block") | RSI("ram_block") | EN, "ram_block"),
   RGN(3 | 0x40011000      | V, IOR                        | ( 5 << 1)        | EN, "USART1"),
   RGN(4 | 0x40012c00      | V, IOR                        | ( 5 << 1)        | EN, "SDMMC1"),
   RGN(5 | 0x40026400      | V, IOR                        | ( 7 << 1)        | EN, "DMA2"),
   RGN(6 | V, 0, 0),
   RGN(7 | V, 0, "stack"),
};

/* Init/Exit MPA template. Used by idle when running ainit() or aexit() */
MPA mpa_tmplt_init = 
{
   RGN(0 | RA("rom_block") | V, PCODE   | SRD("rom_block") | RSI("rom_block") | EN, "rom_block"),
   RGN(1 | RA("sram_block")| V, PDATARW | SRD("sram_block")| RSI("sram_block")| EN, "sram_block"),
   RGN(2 | RA("ram_block") | V, PDATARW | SRD("ram_block") | RSI("ram_block") | EN, "ram_block"),
   RGN(3 | 0x40000000      | V, PIOR    | RSIN(0x80000)    | EN, "IO Regs"),
   RGN(4 | V, 0, 0),
   RGN(5 | V, 0, 0),
   RGN(6 | V, 0, 0),
   RGN(7 | V, 0, "stack"),
};

/* Notes:
   1. Exported from pdx.icf 
   2. Called "blocks" in pdx.icf, but as "sections" here.
*/
#endif /* SMX_CFG_MPU */
